/**
 * 弹出选择列表插件
 * 此组件依赖 listpcker ，请在页面中先引入 mui.picker.css + mui.picker.js
 * varstion 1.0.1
 * by Houfeng
 * Houfeng@DCloud.io
 */

(function($, document) {

	//创建 DOM
	$.dom = function(str) {
		if (typeof(str) !== 'string') {
			if ((str instanceof Array) || (str[0] && str.length)) {
				return [].slice.call(str);
			} else {
				return [str];
			}
		}
		if (!$.__create_dom_div__) {
			$.__create_dom_div__ = document.createElement('div');
		}
		$.__create_dom_div__.innerHTML = str;
		return [].slice.call($.__create_dom_div__.childNodes);
	};

	var panelBuffer = '<div class="mui-poppicker">\
		<div class="title">title</div>\
		<div class="mui-poppicker-body">\
		</div>\
		<div class="buttons">\
			<button class="main-color-button mui-poppicker-btn-ok">确定</button>\
		</div>\
	</div>';

	var pickerBuffer = '<div class="mui-picker">\
		<div class="mui-picker-inner">\
			<div class="main-color-bg my-pciker-line-left"></div>\
			<div class="main-color-bg my-pciker-line-right"></div>\
			<ul class="main-color mui-pciker-list">\
			</ul>\
		</div>\
	</div>';

	//定义弹出选择器类
	var PopPicker = $.ScinanPickerDialog = $.Class.extend({
		//构造函数
		init: function(options) {
			var self = this;
			self.options = options || {};
			self.options.title = self.options.title || "";//标题
			self.options.buttonText = self.options.buttonText || "确认";
			self.panel = $.dom(panelBuffer)[0];
			document.body.appendChild(self.panel);
			self.title = self.panel.querySelector('.title');
			self.ok = self.panel.querySelector('.mui-poppicker-btn-ok');
			self.body = self.panel.querySelector('.mui-poppicker-body');
			self.mask = $.createMask();
			self.ok.innerText = self.options.buttonText;
			self.title.innerText = self.options.title;
			self.ok.addEventListener('tap', function(event) {
				if (self.callback) {
					var rs = self.callback(self.getSelectedItems());
					if (rs !== false) {
						self.hide();
					}
				}
			}, false);
			self.mask[0].addEventListener('tap', function() {
				self.hide();
			}, false);
			self._createPicker();
			//防止滚动穿透
			self.panel.addEventListener($.EVENT_START, function(event) {
				event.preventDefault();
			}, false);
			self.panel.addEventListener($.EVENT_MOVE, function(event) {
				event.preventDefault();
			}, false);
		},
		_createPicker: function() {
			var self = this;
			var layer = self.options.layer || 1;
			var width = (100 / layer) + '%';
			self.pickers = [];
			for (var i = 1; i <= layer; i++) {
				var pickerElement = $.dom(pickerBuffer)[0];
				pickerElement.style.width = width;
				self.body.appendChild(pickerElement);
				var picker = $(pickerElement).picker();
				self.pickers.push(picker);
				pickerElement.addEventListener('change', function(event) {
					var nextPickerElement = this.nextSibling;
					if (nextPickerElement && nextPickerElement.picker) {
						var eventData = event.detail || {};
						var preItem = eventData.item || {};
						nextPickerElement.picker.setItems(preItem.children);
					}
				}, false);
			}
		},
		//填充数据
		setData: function(data) {
			var self = this;
			data = data || [];
			self.pickers[0].setItems(data);
		},
		//获取选中的项（数组）
		getSelectedItems: function() {
			var self = this;
			var items = [];
			for (var i in self.pickers) {
				var picker = self.pickers[i];
				items.push(picker.getSelectedItem() || {});
			}
			return items[0];
		},
		//显示
		show: function(callback) {
			var self = this;
			self.callback = callback;
			self.mask.show();
			document.body.classList.add($.className('poppicker-active-for-page'));
			self.panel.classList.add($.className('active'));
			//处理物理返回键
			self.__back = $.back;
			$.back = function() {
				self.hide();
			};
		},
		//隐藏
		hide: function() {
			var self = this;
			if (self.disposed) return;
			self.panel.classList.remove($.className('active'));
			self.mask.close();
			document.body.classList.remove($.className('poppicker-active-for-page'));
			//处理物理返回键
			$.back=self.__back;
		},
		dispose: function() {
			var self = this;
			self.hide();
			setTimeout(function() {
				self.panel.parentNode.removeChild(self.panel);
				for (var name in self) {
					self[name] = null;
					delete self[name];
				};
				self.disposed = true;
			}, 300);
		}
	});
	
	var panelEditDialog = '<div class="mui-poppicker" style="height:210px">\
		<div class="title">title</div>\
		<div class="mui-poppicker-body" style="height:120px">\
			<div class="plus-button main-color-button iconfont icon-add"></div>\
			<div class="select-text">1</div>\
			<div class="reduce-button main-color-button iconfont icon-minus"></div>\
		</div>\
		<div class="buttons">\
			<button class="main-color-button mui-poppicker-btn-ok">确定</button>\
		</div>\
	</div>';

	//定义弹出选择器类
	$.ScinanEditDialog = $.Class.extend({
		//构造函数
		init: function(options) {
			var self = this;
			self.options = options || {};
			self.options.title = self.options.title || "";//标题
			self.options.buttonText = self.options.buttonText || "确认";
			self.options.errorCallback = self.options.errorCallback;//标题
			self.panel = $.dom(panelEditDialog)[0];
			self.selectPosition = 0;
			document.body.appendChild(self.panel);
			self.title = self.panel.querySelector('.title');
			self.ok = self.panel.querySelector('.mui-poppicker-btn-ok');
			self.body = self.panel.querySelector('.mui-poppicker-body');
			self.itemText = self.panel.querySelector('.select-text');
			self.mask = $.createMask();
			self.ok.innerText = self.options.buttonText;
			self.title.innerText = self.options.title;
			self.ok.addEventListener('tap', function(event) {
				if (self.callback) {
					var rs = self.callback( self.getSelectedText(), self.getSelectedPosition() );
					if (rs !== false) {
						self.hide();
					}
				}
			}, false);
			self.panel.querySelector('.plus-button').addEventListener('tap', function(event) {
				if( !self._data || !self._data.length ){
					return;
				}
				if( self.selectPosition >= ( self._data.length - 1 ) ){
					if( self.options.errorCallback ) {
						self.options.errorCallback();
					}
					return;
				}
				self.setSelected( self.selectPosition + 1 );
			}, false);
			self.panel.querySelector('.reduce-button').addEventListener('tap', function(event) {
				if( !self._data || !self._data.length ){
					return;
				}
				if( self.selectPosition <= 0 ){
					if( self.options.errorCallback ) {
						self.options.errorCallback();
					}
					return;
				}
				self.setSelected( self.selectPosition - 1 );
			}, false);
			self.mask[0].addEventListener('tap', function() {
				self.hide();
			}, false);
			//防止滚动穿透
			self.panel.addEventListener($.EVENT_START, function(event) {
				event.preventDefault();
			}, false);
			self.panel.addEventListener($.EVENT_MOVE, function(event) {
				event.preventDefault();
			}, false);
		},
		//填充数据
		setData: function(data) {
			var self = this;
			data = data || [];
			self._data = data;
			self.setSelected( 0 );
		},
		setSelected: function( position ){
			var self = this;
			if( !self._data || !self._data.length ){
				self.selectPosition = 0;
				return;
			}
			if( position < 0 ){
				position = 0;
			} else if( position >= self._data.length ){
				position = position % self._data.length;
			}
			self.selectPosition = position;
			self.itemText.innerText = self._data[ position ] || '';
		},
		//获取选中的项
		getSelectedText: function() {
			var self = this;
			return self.itemText.innerText;
		},
		//获取选中的项
		getSelectedPosition: function() {
			return this.selectPosition;
		},
		//显示
		show: function(callback) {
			var self = this;
			self.callback = callback;
			self.mask.show();
			document.body.classList.add($.className('poppicker-active-for-page'));
			self.panel.classList.add($.className('active'));
			//处理物理返回键
			self.__back = $.back;
			$.back = function() {
				self.hide();
			};
		},
		//隐藏
		hide: function() {
			var self = this;
			if (self.disposed) return;
			self.panel.classList.remove($.className('active'));
			self.mask.close();
			document.body.classList.remove($.className('poppicker-active-for-page'));
			//处理物理返回键
			$.back=self.__back;
		},
		dispose: function() {
			var self = this;
			self.hide();
			setTimeout(function() {
				self.panel.parentNode.removeChild(self.panel);
				for (var name in self) {
					self[name] = null;
					delete self[name];
				};
				self.disposed = true;
			}, 300);
		}
	});
	
	var panelInputDialog = '<div class="mui-poppicker" style="height:170px">\
		<div class="title">title</div>\
		<div class="mui-poppicker-body" style="height:80px;text-align:center;">\
			<input type="number" style="margin:20px 0;width:95%"/>\
		</div>\
		<div class="buttons">\
			<button class="main-color-button mui-poppicker-btn-ok">确定</button>\
		</div>\
	</div>';

	//定义input选择器类
	$.ScinanInputDialog = $.Class.extend({
		//构造函数
		init: function(options) {
			var self = this;
			self.options = options || {};
			self.options.title = self.options.title || "";//标题
			self.options.buttonText = self.options.buttonText || "确认";
			self.options.placeholder = self.options.placeholder || "";
			self.options.errorCallback = self.options.errorCallback;
			self.panel = $.dom(panelInputDialog)[0];
			document.body.appendChild(self.panel);
			self.title = self.panel.querySelector('.title');
			self.ok = self.panel.querySelector('.mui-poppicker-btn-ok');
			self.body = self.panel.querySelector('.mui-poppicker-body');
			self.input = self.panel.querySelector('input');
			self.input.setAttribute("placeholder",self.options.placeholder);
			self.mask = $.createMask();
			self.ok.innerText = self.options.buttonText;
			self.title.innerText = self.options.title;
			self.ok.addEventListener('tap', function(event) {
				if (self.callback) {
					var rs = self.callback( self.input.value );
					if (rs !== false) {
						self.hide();
					}
				}
			}, false);
			self.mask[0].addEventListener('tap', function() {
				self.hide();
			}, false);
		},
		//显示
		show: function(text,callback) {
			var self = this;
			self.callback = callback;
			self.mask.show();
			self.input.value = text || "";
			document.body.classList.add($.className('poppicker-active-for-page'));
			self.panel.classList.add($.className('active'));
			//处理物理返回键
			self.__back = $.back;
			$.back = function() {
				self.hide();
			};
		},
		//隐藏
		hide: function() {
			var self = this;
			if (self.disposed) return;
			self.panel.classList.remove($.className('active'));
			self.mask.close();
			document.body.classList.remove($.className('poppicker-active-for-page'));
			//处理物理返回键
			$.back=self.__back;
		},
		dispose: function() {
			var self = this;
			self.hide();
			setTimeout(function() {
				self.panel.parentNode.removeChild(self.panel);
				for (var name in self) {
					self[name] = null;
					delete self[name];
				};
				self.disposed = true;
			}, 300);
		}
	});

})(mui, document);