(function(){
	var pickerTemplate = '<div class="scinan-time-picker">\
				<div class="main-color-bg picker-line-left"></div>\
				<div class="main-color picker-hour-text">时</div>\
				<div class="main-color-bg picker-line-middle"></div>\
				<div class="main-color picker-minute-text">分</div>\
				<div class="main-color-bg picker-line-right"></div>\
				<div class="mui-picker">\
					<div class="mui-picker-inner">\
						<ul class="main-color mui-pciker-list">\
						</ul>\
					</div>\
				</div>\
				<div class="mui-picker">\
					<div class="mui-picker-inner">\
						<ul class="main-color mui-pciker-list">\
						</ul>\
					</div>\
				</div>\
			</div>';
	//时间选择器
	Vue.component('scinan-time-picker',{
    	template: pickerTemplate,
    	props: ['hour', "minute"],
    	computed:{
    		hourValue: function(){
    			return ( Math.floor( this.hour * 1 || 0 ) % 24 );
    		},
    		minuteValue: function(){
    			return ( Math.floor( this.minute * 1 || 0 ) % 60 );
    		}
    	},
    	mounted:function(){
    		var t = this;
			var pickerHolder = {
				getData:function() {
					return {
						hour: this[ 'hour' ].getSelectedItem().text,
						minute: this[ 'minute' ].getSelectedItem().text
					};
				}
			};
			var bindEvent = function( el, num, name ){
				var items = [];
				for( var i = 0; i < num; i++ ){
	    			items.push( {
	    				value: i,
	    				text: (i < 10 ? '0' : '' ) + i
	    			} );
	    		}
				var picker = mui( el ).picker();
				pickerHolder[ name ] = picker;
				picker.setItems( items );
				var changefun = function(){
					t.$emit( 'change' , pickerHolder.getData() );
					t[ name ] = picker.getSelectedItem().text;
				};
				picker.setSelectedValue( t[ name + "Value" ] );
				t.$watch( name + "Value", function( value ){
					picker.setSelectedValue( value );
				} );
				el.addEventListener('change', function(event) {
					changefun();
				}, false);
			};
			var el = t.$el.getElementsByClassName("mui-picker");
			bindEvent( el[ 0 ], 24 , "hour" );
			bindEvent( el[ 1 ], 60, "minute" );
    	}
   	});
   	
   	var tableTemplate ='<div style="background:white">\
			<svg v-bind:viewBox="box" style="width: 100%;height: 100%;display: block;">\
				<line v-bind="Xaxis" style="fill:none;stroke-width:1" />\
				<line v-bind="Yaxis" style="fill:none;stroke-width:1" />\
				<text text-anchor="start" v-bind:x="startX" y="12" v-bind:fill="colorText" style="font-size:8">kW·h</text>\
				<polyline v-bind:points="line" v-bind:stroke="colorLine" style="fill:none;stroke-width:1" />\
				<path v-for="item in unitLines" v-bind:d="item.d" fill="none" v-bind:stroke="colorLine" stroke-width="0.5"/>\
				<text v-for="item in unitLines" text-anchor="end" v-bind:x="startX-4" v-bind:y="item.y+4" v-bind:fill="colorText" style="font-size:8">{{item.num}}</text>\
				<path v-bind:d="path" v-bind:fill="colorFill" />\
				<polyline v-bind:points="line" v-bind:stroke="colorLine" style="fill:none;stroke-width:1" />\
				<text v-for="item in stats" text-anchor="middle" v-bind:x="item.x" v-bind:y="startY+8" v-bind:fill="colorText" style="font-size:8">{{item.name}}</text>\
				<circle v-for="item in stats" v-bind:cx="item.x" v-bind:cy="item.y" r="1.5" v-bind:fill="colorLine" />\
			</svg>\
		</div>';
	Vue.component('scinan-table',{
    	template:tableTemplate,
    	//unit:纵坐标单位; minUnit:最小纵坐标; ratio:（高度/宽度) 数值
    	//只有list可以动态改变
    	//list:[{num:数值,name:可选,显示在x轴上的名字}]
    	props: ['list',"ratio",'unit',"minUnit","lineColor","fillColor","textColor"],
    	data:function(){
    		var t = this;
    		var dayNum = 7,
    			goal = 2.5, unit = 1;
    			
    		var width = 260,startX = 20, endX = 240;
    		var height = 120;
    		if( !isNaN( t.ratio * 1 ) ){
    			height = width * t.ratio;
    		}
    		var startY = height * 0.9,endY = height * 0.25;
    		var colorLine = t.lineColor || "#00F";
    		return {
    			unitMin: ( t.minUnit * 1 ) || 2,
    			colorText: t.textColor || "#00F",
	    		colorLine: colorLine,
	    		colorFill: t.fillColor || "rgba(0,0,255,0.5)",
	    		box: "0 0 " + width + " " + height,
	    		startX: startX,
    			endX: endX,
    			startY: startY,
    			endY: endY,
    			Xaxis:{
    				x1:startX,
    				x2:250,
    				y1:startY,
    				y2:startY,
    				stroke:colorLine
    			},
    			Yaxis:{
    				x1:startX,
    				x2:startX,
    				y1:startY,
    				y2:height * 0.15,
    				stroke:colorLine
    			}
    		}
    	},
    	computed:{
    		dataList:function(){
    			if( Object.prototype.toString.call( this.list ) == "[object Array]" ){
    				return this.list;
    			}
    			return [];
    		},
    		maxNum: function(){
    			var t = this;
    			return t.dataList.reduce( function( a , b ){
    					if( isNaN( b.num * 1 ) ){
    						return a;
    					}
    					return a > b.num ? a : b.num;
    				}, t.unitMin );
    		},
    		dx:function(){
    			var t = this;
    			var allX = t.endX - t.startX;
    			return ( allX / ( ( t.dataList.length - 1 ) || 1 ) );
    		},
    		dy: function(){
    			var t = this;
    			var allY = t.endY - t.startY;
    			return ( allY / t.maxNum );
    		},
    		stats:function(){
    			var t = this;
    			var list = t.dataList;
    			if( !list.length ){
    				return [{num: 0,name: "",x: t.startX,y: t.startY},
    					{num: 0,name: "",x: t.endX,y: t.startY}];
    			}
    			var startX = t.startX, startY = t.startY , dx = t.dx, dy = t.dy;
    			var resultList = list.map( function( item, index ){
    				var num = ( item.num * 1 ) || 0;
    				return {
    					num: item.num,
    					name: item.name != null ? item.name : "",
    					x: startX + index  * dx,
    					y: startY + num * dy
    				};
    			} );
    			if( resultList.length==1 ){
    				resultList.unshift({num: 0,name: "",x: t.startX,y: t.startY});
    			}
    			return resultList;
    		},
    		unitY:function(){
    			var maxNum = this.maxNum;
    			var ln10 = Math.floor( ( Math.log( maxNum || 1 ) / Math.log( 10 ) ) );
    			if( ln10 >= 0 ){
    				return Math.pow( 10, ln10 );
    			}
    			return 1;
    		},
    		unitLines:function(){
    			var list = [], t = this;
    			var unit = t.unitY;
    			var dy = t.dy * unit;
    			var y = t.startY;
    			var startX = t.startX, endX = t.endX, endY = t.endY;
    			var i = 0;
    			for( ; y >= endY; y += dy, i++  ){
    				list.push( {
    					y: y,
    					d:'M' + startX + ' ' + y + ' l' + ( endX - startX ) + ' 0',
    					num: i * unit
    				} );
    			}
    			return list;
    		},
    		line:function(){
    			var t = this;
    			var stats = t.stats;
    			var str = '';
    			for( var i = 0; i < stats.length; i++){
    				str += stats[ i ].x + ',' + stats[ i ].y + ' ';
    			}
    			return str;
    		},
    		path:function(){
    			var stats = this.stats;
    			var y = this.startY;
    			var str = 'M'+ stats[ 0 ].x + ' ' + y + ' ';
    			for( var i = 0; i < stats.length; i++){
    				str += 'L' + stats[ i ].x + ' ' + stats[ i ].y  + ' ';
    			}
    			str += 'L' + stats[ i - 1 ].x + ' ' + y +' Z';
    			return str;
    		}
    	}
    });
})();
